{-------------------------------------------------------------------------}
{                     EP.INC   Set Epson Printer                          }
{-------------------------------------------------------------------------}
{                                                                         }
{                  Copyright 1985                                         }
{                                 by Karson W. Morrison                   }
{                                    RD 1, Box 531                        }
{                                    Ringoes, NJ 08551                    }
{                                          and                            }
{                                    Lynn A. Canning                      }
{                                    9107 Grandview Dr.                   }
{                                    Overland Park, Ks 66212              }
{-------------------------------------------------------------------------}
const
   cons0      = '0) Reset (Power up state)';
   cons1      = '1) Pica';
   cons2      = '2) Elite';
   cons3      = '3) Italic';
   cons4      = '4) Enlarged';
   cons5      = '5) Emphasized';
   cons6      = '6) Condensed';
   cons7      = '7) Subscript';
   cons8      = '8) Double Strike';
   cons9      = '9) Proportional';
   consA      = 'A) 1/6   inch line spacing';
   consB      = 'B) 1/8   inch line spacing';
   consC      = 'C) 7/72  inch line spacing';
   consD      = 'D) n/216 inch line spacing';
   consE      = 'E) Double spacing';
   consF      = 'F) Skip Over Perforation';
   consG      = 'G) Set Left Margin';
   consH      = 'H) Printer Line Advance';
   consI      = 'I) Printer Page Advance';
   consJ      = 'J) Print a Test Pattern';
   consK      = 'K) Small Printed Listing';
   consX      = 'X) Exit Program';
   head1      = 'TEST OPTIONS';
   cons216    = 'The valid values are 0 thru 256';
   consPica   = 'In Pica mode the number selected must be 0 thru 134';
   consCond   = 'In Condensed mode the number selected must be 0 thru 229';
   consElite  = 'In Elite mode the number selected must be 0 thru 160';
   SWON       = ' ON';
   SWOFF      = '   ';
var
   cx,cy,
   i,Num,t,result    : Integer;
   Ch                : Char;
   SW                : Array[1..17] OF String[3];
   cntl,numin        : string[3];
   goodinp           : boolean;

{ Internal Routines Begin Here ****************************** }
   procedure WriteAlpha;
   begin
     textcolor(Rxx);
     gotoXY(1,7);
     Writeln(sw[1]);
     Writeln(sw[2]);
     Writeln(sw[3]);
     Writeln(sw[4]);
     Writeln(sw[5]);
     Writeln(sw[6]);
     Writeln(sw[7]);
     Writeln(sw[8]);
     Writeln(sw[9]);
     gotoXY(37,7);
     Writeln(sw[10]);
     gotoXY(37,8);
     Writeln(sw[11]);
     gotoXY(37,9);
     Writeln(sw[12]);
     gotoXY(37,10);
     Writeln(sw[13]:3);
     gotoXY(37,11);
     Writeln(sw[14]);
     gotoXY(37,12);
     Writeln(sw[15]);
     gotoXY(37,13);
     Writeln(sw[16]:3);
     gotoXY(1,18);
     Writeln(sw[17]);
   end;

   procedure Window1;
   begin
      Writexy('Epson Printer Setup             Written by ',BkCxx,7,2,0);
      Writexy('Version 4.10            Karson W. Morrison and Lynn A. Canning',BkCxx,7,3,0);
      GoToXY(4,5);
      Writexy('CHARACTER OPTIONS                   LINE SPACING OPTIONS',BlCxx,6,5,0);
      Writexy(cons1,BlCxx,9,7,0);
      Writexy(cons2,BlCxx,9,8,0);
      Writexy(cons3,BlCxx,9,9,0);
      Writexy(cons4,BlCxx,9,10,0);
      Writexy(cons5,BlCxx,9,11,0);
      Writexy(cons6,BlCxx,9,12,0);
      Writexy(cons7,BlCxx,9,13,0);
      Writexy(cons8,BlCxx,9,14,0);
      Writexy(cons9,BlCxx,9,15,0);
      Writexy(cons0,BlCxx,9,16,0);
      Writexy(consK,BlCxx,9,18,0);
      Writexy(consX,BlCxx,9,20,0);
      Writexy(consA,BlCxx,45,7,0);
      Writexy(consB,BlCxx,45,8,0);
      Writexy(consC,BlCxx,45,9,0);
      Writexy(consD,BlCxx,45,10,0);
      Writexy(consE,BlCxx,45,11,0);
      Writexy(consF,BlCxx,45,12,0);
      Writexy(consG,BlCxx,45,13,0);
      Writexy(head1,BlCxx,42,15,0);
      Writexy(consH,BlCxx,45,17,0);
      Writexy(consI,BlCxx,45,18,0);
      Writexy(consJ,BlCxx,45,19,0);
      Writexy('Option Wanted ',BlCxx,26,22,0);
      WriteAlpha;
   end;

   PROCEDURE Window2;
   BEGIN
     Open(2);
     Writexy('Set n/216 Line Spacing',Gxx,27,7,0);
     Writexy('Examples',Gxx,33,9,0);
     Writexy('Normal spacing of 6 lines per inch would be 36/216',Gxx,13,11,0);
     Writexy('7/72 is approxmiately 10 lines per inch or 21/216',Gxx,13,12,0);
     Writexy('The Double Space option used in this program is 54/216',Gxx,13,13,0);
     Writexy(cons216,Gxx,21,15,0);
     repeat
        Writexy('Enter Selected Number followed by Carriage Return    ',Gxx,10,17,0);
        GoToXY(60,12);
        num := 256;
        Read(Numin);
        Val(numin,num,result);
        goodinp := false;
        if num in [0..255] then
          goodinp := true
        else
          begin
            Writexy(cons216,Rxx+128,21,15,0);
            Write(^G);
          end;
       until goodinp;
       Remove(1);
     end;

   PROCEDURE Window5;
   BEGIN
     Open(2);
     Writexy('Set Left Margin',Gxx,27,7,0);
     Writexy('The maximum value that can be selected is determined by',Gxx,13,9,0);
     Writexy('the current print mode.  Illegal settings are ignored.',Gxx,13,10,0);
     Writexy(consPica,Gxx,13,12,0);
     Writexy(consCond,Gxx,13,13,0);
     Writexy(consElite,Gxx,13,14,0);
     repeat
        Writexy('Enter Selected Number followed by Carriage Return    ',Gxx,10,17,0);
        GoToXY(60,12);
        num := 256;
        Read(Numin);
        Val(numin,num,result);
        goodinp := false;
        if (sw[1] = SWON) and (sw[6] = SWON) then
          if num in [0..229] then
            goodinp := true
          else
            Writexy(consCond,Rxx+128,13,13,0);
        if (sw[1] = SWON) and (sw[6] = SWOFF) then
          if num in [0..134] then
            goodinp := true
          else
            Writexy(consPica,Rxx+128,13,12,0);
        if sw[2] = SWON then
          if num in [0..160] then
            goodinp := true
          else
            Writexy(consElite,Rxx+128,13,14,0);
        if not goodinp then write(^G);
       until goodinp;
     Remove(1);
     end;

   procedure CheckInput;
   begin
      TextColor(Blxx);
      Read(Kbd,Ch);
      Ch := UpCase(Ch);
      Write(Ch);
      if Ch='0' then
      begin
         FOR t := 1 TO 17 DO
           sw[t] := SWOFF;
         sw[1] := SWON;
         sw[10] := SWON;
         Write(Lst,#$1B#$40);                    { function0 }
         Open(3);
         ClrScr;
         Writeln;
         Writeln('  Reset printer option causes the top of form to be where the printer is now');
         Writeln('     Remember to line up the paper in your printer');
         For t := 1 TO 4 DO begin
           Write(Lst,^G^G);
           Delay(200);
           end;
         TimeDelay(4);
         Remove(1);
      end;
      if Ch='1' then begin Write(Lst,#$1B#$50);  { function1 }
        sw[1] := SWON;
        sw[2] := SWOFF;
        end;
      if Ch='2' then begin Write(Lst,#$1B#$4D);  { function2 }
        sw[1] := SWOFF;
        sw[2] := SWON;
        end;
      if Ch='3' then                             { function 3 }
       if (sw[3] = SWOFF) then begin
        Write(Lst,#$1B#$34);
        sw[3] := SWON;
        end
       else begin
        Write(Lst,#$1B#$35);
        sw[3] := SWOFF;
        end;
      if Ch='4' then                             { function 4 }
       if (sw[4] = SWOFF) then begin
        Write(Lst,#$1B#$57#$31);
        sw[4] := SWON;
        end
       else begin
        Write(Lst,#$1B#$57#$30);
        sw[4] := SWOFF;
        end;
      if Ch='5' then                             { function 5 }
       if (sw[5] = SWOFF) then begin
        Write(Lst,#$1B#$45);
        sw[5] := SWON;
        end
       else begin
        Write(Lst,#$1B#$46);
        sw[5] := SWOFF;
        end;
      if Ch='6' then
       if (sw[6] = SWOFF) then begin
        Write(Lst,#$0F);                         { function6 }
        sw[6] := SWON;
        end
       else begin
        Write(Lst,#$12);
        sw[6] := SWOFF;
        end;
      if Ch='7' then                             { function 7 }
       if (sw[7] = SWOFF) then begin
        Write(Lst,#$1B#$53#$31);
        sw[7] := SWON;
        end
       else begin
        Write(Lst,#$1B#$54);
        sw[7] := SWOFF;
        end;
      if Ch='8' then
       if (sw[8] = SWOFF) then begin
        Write(Lst,#$1B#$47);                     { function8 }
        sw[8] := SWON;
        end
       else begin
        Write(Lst,#$1B#$48);
        sw[8] := SWOFF;
        end;
      if Ch='9' then
       if (sw[9] = SWOFF) then begin
        Write(Lst,#$1B#$70#$31);                 { function9 }
        sw[9] := SWON;
        end
       else begin
        Write(Lst,#$1B#$70#$30);
        sw[9] := SWOFF;
        end;
      if Ch='A' then begin
        Write(Lst,#$1B#$32);                     { functionA }
        FOR t := 10 TO 14 DO
          sw[t] := SWOFF;
        sw[10] := SWON;
        end;
      if Ch='B' then begin
        Write(Lst,#$1B#$30);                     { functionB }
        FOR t := 10 TO 14 DO
          sw[t] := SWOFF;
        sw[11] := SWON;
        end;
      if Ch='C' then begin
        Write(Lst,#$1B#$31);                     { functionC }
        FOR t := 10 TO 14 DO
          sw[t] := SWOFF;
        sw[12] := SWON;
        end;
      if Ch='D' then begin                       { functionD }
        window2;
        FOR t := 10 to 14 DO
          sw[t] := SWOFF;
        sw[13] := numin;
        Write(Lst,Chr(27)+Chr(51)+Chr(Num));
        end;
      if Ch='E' then begin
        Write(Lst,#$1B#$41#$18);                 { functionE }
        FOR t := 10 TO 14 DO
          sw[t] := SWOFF;
        sw[14] := SWON;
        end;
      if Ch='F' then
       if (sw[15] = SWOFF) then begin
        Write(Lst,#$1B#$4E#$06);                 { functionF }
        sw[15] := SWON;
        end
       else begin
        Write(Lst,#$1B#$4F);
        sw[15] := SWOFF;
        end;
      if Ch='G' then begin                       { functionG }
        window5;
        textcolor(blue);
        sw[16] := numin;
        Write(Lst,Chr(27)+Chr(108)+Chr(Num));
        end;
      if Ch='K' then
        if (sw[17] = SWOFF) then begin
          sw[17] := SWON;
          sw[6] := SWON;
          sw[7] := SWON;
          sw[15] := SWON;
          sw[16] := ' 12';
          for t := 10 TO 14 DO
            sw[t] := SWOFF;
          sw[13] := ' 15';
          Write(Lst,#$0F);                     {condensed on}
          Write(Lst,#$1B#$53#$31);             {subscript on}
          Write(Lst,Chr(27)+Chr(51)+Chr(15));  {15/216 line spacing}
          Write(Lst,#$1B#$4E#$06);             {skip perforation}
          Write(Lst,Chr(27)+Chr(108)+Chr(12)); {indent 12 spaces}
          end
        else begin
          sw[17] := SWOFF;
          sw[6] := SWOFF;
          sw[7] := SWOFF;
          sw[15] := SWOFF;
          sw[16] := SWOFF;
          sw[13] := SWOFF;
          for t := 10 TO 14 DO
            sw[t] := SWOFF;
          sw[10] := SWON;
          Write(Lst,#$12);                     {condensed off}
          Write(Lst,#$1B#$54);                 {subscript off}
          Write(Lst,#$1B#$32);                 {1/6 line spacing}
          Write(Lst,#$1B#$4F);                 {skip perforation off}
          Write(Lst,Chr(27)+Chr(108)+Chr(0));  {indent 0 spaces}
          end;

      WriteAlpha;
      if Ch='H' then Write(Lst,#$0A);            { functionH }
      if Ch='I' then Write(Lst,#$0C);            { functionI }
      if Ch='J' then                             { functionJ }
      begin
         Write(Lst,'OPTIONS--> ');
         if (sw[1]  = SWON) then Write(Lst,'-Pica ');
         if (sw[2]  = SWON) then Write(Lst,'-Elite ');
         if (sw[3]  = SWON) then Write(Lst,'-Italic ');
         if (sw[4]  = SWON) then Write(Lst,'-Expanded ');
         if (sw[5]  = SWON) then Write(Lst,'-Emphasized ');
         if (sw[6]  = SWON) then Write(Lst,'-Compressed ');
         if (sw[7]  = SWON) then Write(Lst,'-Subscript ');
         if (sw[8]  = SWON) then Write(Lst,'-Double-strike ');
         if (sw[9]  = SWON) then Write(Lst,'-Proportional ');
         if (sw[10] = SWON) then Write(Lst,'-1/6" ');
         if (sw[11] = SWON) then Write(Lst,'-1/8" ');
         if (sw[12] = SWON) then Write(Lst,'-7/72" ');
         if NOT (sw[13] = SWOFF) then Write(Lst,'-',sw[13],'/216 ');
         if (sw[14] = SWON) then Write(Lst,'-Double-space ');
         if (sw[15] = SWON) then Write(Lst,'-Skip-perf ');
         if NOT (sw[16] = SWOFF) then Write(Lst,'-Left Margin=',sw[16]);
         Writeln(Lst,' ');
         Writeln(Lst,'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890');
         Writeln(Lst,'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890');
         Writeln(Lst,'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890');
         Writeln(Lst,' ');
      end;
   end;

{ Main Program Begins Here ********************************** }


BEGIN
 Initialize;
 SetVideo;
 cx := Wherex;
 cy := Wherey;
 SetWindow(1,4,0,74,24,RBlxx,BlCxx,3,0,'',0,0,3);
 SetWindow(2,0,5,79,19,Gxx,Gxx,2,1,'',0,0,2);
 SetWindow(3,0,9,79,14,Rxx,Rxx,8,0,'',0,0,8);
 Open(1);
 FOR t := 1 TO 17 DO
   sw[t] := SWOFF;
 sw[1] := SWON;
 sw[10] := SWON;
 Write(Lst,#$1B#$40);                               {reset Printer}
 Window1;
 repeat
      GoToXY(36,22);
      CheckInput;
 until UpCase(Ch) = 'X';
 Remove(1);
 gotoxy(cx,cy);
end;
