{$V-}
{-------------------------------------------------------------------------}
{                     TICKLER EDITOR                                      }
{-------------------------------------------------------------------------}
{                Copyright 1986                                           }
{                              by Lynn A. Canning                         }
{                                  9107 Grandview Dr.                     }
{                                  Overland Park, Ks 66212                }
{-------------------------------------------------------------------------}
const
  Drive_path  :string[12] = '\';
  Infilename = 'tickler.dat';
  Outfilename = 'tickler.$$$';
  Julian : array [1..12] of integer =
               (000,031,060,091,121,152,182,213,244,274,305,335);
type
  CharSet    = set of Char;
  AnyStr     =  string[75];
  Str50      =  string[50];
var
  Infile,Outfile      :text;
  Inwork               :string[75];
  result               :integer;
  I,J,cx,cy            :integer;
  ch,TC                :char;
  Mst,Mwkday           :string[1];
  Mday,Mmon,Mampm,Mts  :string[2];
  Myr                  :string[4];
  Mtime                :string[5];
  Mmesg                :string[50];
  Jday                 :string[3];
  goodfile,
  goodinp,SaveSw       :boolean;
  D,M,W,Juldate        :integer;

{----------------------------------------------------------------------------}
{                          STRING EDITOR                                     }
{----------------------------------------------------------------------------}
function ConstStr(C : Char; N : Integer) : Str50;
var
  S : string[50];
begin
  if N < 0 then
    N := 0;
  S[0] := Chr(N);
  FillChar(S[1],N,C);
  ConstStr := S;
end;

procedure Beep;
begin
  Write(^G);
end;

procedure InputStr(var S     : AnyStr;
                       L,X,Y : Integer;
                       Term  : CharSet;
                   var TC    : Char    );
const
  UnderScore  =  '_';
var
  P : Integer;
  Ch : Char;
begin
  GotoXY(X,Y); Write(S,ConstStr(UnderScore,L - Length(S)));
  P := 0;
  repeat
    GotoXY(X + P,Y); Read(Kbd,Ch);
    case Ch of
      #27       : begin
                    Read(Kbd,Ch);
                    case Ch of
                      'K'  :  if P > 0 then P := P -1
                                else Beep;
                      'M'  :  if P < length(S) then P := P + 1
                                else Beep;
                      'G'  :  P := 0;
                      'O'  :  P := length(S);
                      'S'  :  if P < length(S) then
                                begin
                                   Delete(S,P+1,1);
                                   Write(Copy(S,P+1,L),UnderScore);
                                end
                    else Beep;
                    end;   { of case }
                 end;
      #32..#126 : if P < L then
                  begin
                    if Length(S) = L then
                      Delete(S,L,1);
                    P := P + 1;
                    Insert(Ch,S,P);
                    Write(Copy(S,P,L));
                  end
                  else Beep;
       ^H,#127 : if P > 0 then
                  begin
                    Delete(S,P,1);
                    Write(^H,Copy(S,P,L),UnderScore);
                    P := P - 1;
                  end
                  else Beep;
     ^Y       : begin
                  Write(ConstStr(UnderScore,Length(S) - P));
                  Delete(S,P + 1,L);
                 end;
    else
      if not (Ch in Term) then Beep;
    end;  {of case}
  until Ch in Term;
  P := Length(S);
  GotoXY(X + P,Y);
  Write('' :L - P);
  TC := Ch;
end;
{----------------------------------------------------------------------------}
{                          I/O ROUTINES                                      }
{----------------------------------------------------------------------------}
procedure SaveRec;
begin
  SaveSw := True;
  Juldate := D + Julian[M];
  Str (Juldate:3,Jday);
  if Jday[1] = ' ' then
    Jday[1] := '0';
  if Jday[2] = ' ' then
    Jday[2] := '0';
  InWork := Jday+Mampm+Mtime+Mts+Mwkday+Mst+Mday+Mmon+Myr+'   '+Mmesg;
  Writeln(Outfile,Inwork);
end;

procedure GetInfile;
begin
  ClrScr;
  Assign(Infile,Drive_path+Infilename);
  {$I-}
  Reset(Infile);
  {$I+}
  if IOResult = 0 then
    goodfile := true
  else
    begin
      goodfile := false;
      gotoxy(2,2);
      write('Input file ');
      textcolor(Rxx);
      write(Drive_path+Infilename);
      textcolor(Brxx);
      writeln(' Not Found ');
      write(' Enter Drive and Path for ');
      textcolor(Rxx);
      write(Infilename);
      gotoxy(2,4);
      readln(Drive_path);
    end;
  textcolor(Brxx);
end;
{----------------------------------------------------------------------------}
{                          INPUT EDITOR                                      }
{----------------------------------------------------------------------------}
procedure edit;
const
  Term : CharSet = [^M,^Z];
begin
  ClrScr;
  goodinp := false;
  Mday := '00';
  Mmon := '00';
  Myr  := '____';
  Mtime := '_____';
  Mampm := '__';
  Mmesg := '';
  Mts := '00';
  Mst := 'T';
  Mwkday := ' ';
  writexy(' MONTH DAY YEAR   TIME    MESSAGE',Gxx,2,6,0);
  writexy(' TIMESPAN  STATUS',Gxx,2,9,0);
  writexy('Enter message month, Press Return',Rxx,15,12,0);
  repeat
    repeat
      InputStr(Mmon,2,3,3,Term,TC);
    until TC in Term;
    Val(Mmon,M,result);
    if (M >= 1) and (M <= 12) then
      goodinp := true
    else begin
      Beep;
      writexy('  Invalid- Re-enter, ',Rxx,15,12,0);
      end
  until goodinp;
  writexy('  Enter message day,',Rxx,15,12,0);
  repeat
    repeat
      InputStr(Mday,2,8,3,Term,TC);
    until TC in Term;
    Val(Mday,D,result);
    if (D >= 1) and (D <= 31) then
      goodinp := true
    else begin
      Beep;
      writexy('  Invalid- Re-enter, ',Rxx,15,12,0);
      end
  until goodinp;
  goodinp := false;
  writexy(' Enter message year, ',Rxx,15,12,0);
  repeat
    InputStr(Myr,4,12,3,Term,TC);
  until TC in Term;
  writexy(' Enter time (hh:mm), ',Rxx,15,12,0);
  repeat
    InputStr(Mtime,5,17,3,Term,TC);
  until TC in Term;
  if Mtime = '_____' then
    Mtime := '     ';
  writexy('    Enter AM or PM,  ',Rxx,15,12,0);
  repeat
    InputStr(Mampm,2,23,3,Term,TC);
  until TC in Term;
  if Mampm = '__' then
    Mampm := '  ';
  writexy('     Enter Message,  ',Rxx,15,12,0);
  repeat
    InputStr(Mmesg,50,27,3,Term,TC);
  until TC in Term;
  writexy('Enter Number of Days in Advance to show Message (00-99)',Rxx,15,12,0);
  repeat
    InputStr(Mts,2,5,6,Term,TC);
  until TC in Term;
  writexy('Enter Message Status (A=Annual Q=Qtr M=Mon W=Wk T=Temp)',Rxx,15,12,0);
  repeat
    InputStr(Mst,1,14,6,Term,TC);
  until TC in Term;
  Mst := UpCase(Mst);
  if Mst = 'W' then
    begin
      goodinp :=false;
      writexy(' DOW',Gxx,20,9,0);
      writexy('Enter day of week for message (1=Sunday 2=Monday, etc.)',Rxx,15,12,0);
      repeat
        repeat
          InputStr(Mwkday,1,21,6,Term,TC);
        until TC in Term;
        Val(Mwkday,W,result);
        if W in [1..7] then
          goodinp := true
        else begin
          Beep;
          writexy('Invalid- Re-enter,             ',Rxx,15,12,0);
          end
        until goodinp;
      end;
  writexy('                                                          ',Rxx,15,12,0);
  repeat
    writexy('Save this message? Y/N  ',Rxx,15,12,0);
    gotoxy(37,8);
    Read(Kbd,ch);
    ch := UpCase(ch);
  until ch in ['N','Y'];
  if ch = 'Y' then
    SaveRec;
end;
{----------------------------------------------------------------------------}
{                           MAIN PROGRAM                                     }
{----------------------------------------------------------------------------}
BEGIN
  Initialize;
  SetVideo;
  cx := Wherex;
  cy := Wherey;
  SaveSw := false;
  SetWindow(1,0,0,79,15,Rxx,0,2,0,'',0,0,2);
  SetWindow(2,1,1,78,3,BlBrxx,BkBrxx,2,0,'',0,0,2);
  SetWindow(3,1,4,78,14,Gxx,Brxx,2,1,'',0,0,2);
  Open(1);
  Open(2);
  Open(3);
  Writexy('TICKLER ADD EDITOR',BlBrxx,5,2,0);
  Writexy('Written by Lynn Canning 1986',BkBrxx,49,2,0);
  repeat
    GetInfile;
  until goodfile;
  ClrScr;
  Assign(Outfile,Drive_path+Outfilename);
  ReWrite(Outfile);
  repeat
    edit;
    writexy('Add another message? Y/N',Rxx,15,12,0);
    gotoxy(39,8);
    repeat
      Read(Kbd,ch);
    until ch in ['Y','y','N','n'];
  until ch in ['N','n'];
  if savesw then
    begin
      writexy('         Saving '+Drive_path+Infilename,Rxx,15,12,0);
      while not EOF(Infile) DO
        begin
          Readln(Infile,Inwork);
          Writeln(Outfile,Inwork);
        end;
  Close(Infile);
  Close(Outfile);
  if savesw then
      Erase(Infile);
      Rename(Outfile,Drive_path+Infilename);
    end
  else
    Erase(Outfile);
  remove(3);
  gotoxy(cx,cy);
  end;
