{-------------------------------------------------------------------------}
{                          VIDOMODE.INC                                   }
{-------------------------------------------------------------------------}
{                Copyright 1986                                           }
{                               by Lynn A. Canning                        }
{                                  9107 Grandview Dr.                     }
{                                  Overland Park, Ks 66212                }
{									  }
{	MODIFIED BY T. BERING 17 APR TO ADD MORE COLOR COMBINATIONS	  }
{		ALL ADDED COLORS/COMBINATIONS COMMENTED IN CAPS.	  }
{-----------------------------------------------------------------------------}
{                   COLOR CONSTANTS FOR PGM-AIDE                              }
{-----------------------------------------------------------------------------}
{  The color constants were set in this module mainly to allow quick          }
{  changing and to allow composite monochrome monitors such as Compaq and     }
{  other portables with this type monitor to operate in monochrome color mode.}
{  Keep in mind that changing the value of a color constant will cause        }
{  all of the include modules in PGM-AIDE to change to the new color.         }
{                                                                             }
{  If you are using a composite monochrome monitor, simply place a "C" as the }
{  first parameter in the command line and the colors in all PGM-AIDE modules }
{  and TICKLER will be changed to shades of black and white.                  }
{-----------------------------------------------------------------------------}

CONST
  Blxx           :integer = 1;     {blue}
  Gxx            :integer = 2;     {green}
  Cxx            :integer = 3;     {cyan}
  Rxx            :integer = 4;     {red}
  Mxx		 :integer = 5;	   {MAGENTA}
  Brxx           :integer = 6;     {brown}
  Wxx		 :integer = 7;	   {WHITE}
  Gyxx		 :integer = 8;	   {DARK GREY}
  LtBlxx         :integer = 9;     {light blue}
  LtGxx		 :integer = 10;	   {LIGHT GREEN}
  LtCxx		 :integer = 11;	   {LIGHT CYAN}
  LtRxx          :integer = 12;    {light red}
  LtMxx		 :integer = 13;	   {LIGHT MAGENTA}
  Yxx		 :integer = 14;	   {YELLOW}
  LtWxx		 :integer = 15;	   {LIGHT WHITE}
  BkBlxx	 :integer = 16;	   {BLACK ON BLUE}
  GBlxx		 :integer = 18;	   {GREEN ON BLUE}
  CBlxx		 :integer = 19;	   {CYAN ON BLUE}
  RBlxx          :integer = 20;    {red on blue}
  MBlxx		 :integer = 21;    {MAGENTA ON BLUE}
  BrBlxx	 :integer = 22;    {BROWN ON BLUE}
  WBlxx		 :integer = 23;    {WHITE ON BLUE}
  GyBlxx	 :integer = 24;    {DARK GREY ON BLUE}
  LtBlBlxx	 :integer = 25;    {LIGHT BLUE ON BLUE}
  LtGBlxx	 :integer = 26;    {LIGHT GREEN ON BLUE}
  LtCBlxx	 :integer = 27;    {LIGHT CYAN ON BLUE}
  LtRBlxx	 :integer = 28;    {LIGHT RED ON BLUE}
  LtMBlxx	 :integer = 29;    {LIGHT MAGENTA ON BLUE}
  YBlxx		 :integer = 30;    {YELLOW ON BLUE}
  LtWBlxx	 :integer = 31;    {LIGHT WHITE ON BLUE}
  BkGxx          :integer = 32;    {black on green}
  BkCxx          :integer = 48;    {black on cyan}
  BlCxx          :integer = 49;    {blue on cyan}
  BkRxx          :integer = 64;    {black on red}
  BlRxx          :integer = 65;    {blue on red}
  BkBrxx         :integer = 96;    {black on brown}
  BlBrxx         :integer = 97;    {blue on brown}
  GBrxx		 :integer = 98;    {GREEN ON BROWN}
  CBrxx		 :integer = 99;    {CYAN ON BROWN}
  RBrxx		 :integer = 100;   {RED ON BROWN}
  MBrxx		 :integer = 101;   {MAGENTA ON BROWN}
  WBrxx		 :integer = 103;   {WHITE ON BROWN}
  GyBrxx	 :integer = 104;   {DARK GREY ON BROWN}
  LtBlBrxx	 :integer = 105;   {LIGHT BLUE ON BROWN}
  LtGBrxx	 :integer = 106;   {LIGHT GREEN ON BROWN}
  LtCBrxx	 :integer = 107;   {LIGHT CYAN ON BROWN}
  LtRBrxx	 :integer = 108;   {LIGHT RED ON BROWN}
  LtMBrxx	 :integer = 109;   {LIGHT MAGENTA ON BROWN}
  YBrxx		 :integer = 110;   {YELLOW ON BROWN}
  LtWBrxx	 :integer = 111;   {LIGHT WHITE ON BROWN}  

  FLASH		 :integer = 128;   {e.g. YBrxx+FLASH causes BLINKING}

var
  video_mode      : byte;
  videostatus     : byte;
  Param1          : string[1];
  Param2          : string[1];
procedure SetVideo;
begin
  video_mode := Mem[0000:$0449];
  if video_mode = 7 then
    VideoStatus := 7;
  Param1 := ParamStr(1);
  Param2 := ParamStr(2);
  Param1[1] := UpCase(Param1[1]);
  Param2[1] := UpCase(Param2[1]);
  if Param1 = 'C' then
    video_mode := 7;
  if video_mode = 7 then begin     {7 is monochrome, 3 is text graphics 80X25}
    Blxx     := 0;
    Gxx      := 7;
    Cxx      := 0;
    Rxx      := 12;
    Brxx     := 15;
    LtBlxx   := 0;
    LtRxx    := 7;
    RBlxx    := 7;
    BkCxx    := 112;
    BlCxx    := 112;
    BkRxx    := 112;
    BlRxx    := 112;
    BkBrxx   := 112;
    BlBrxx   := 112;
  end;
end;

{------------------------------------------------------------------}
{                     Delay for  X seconds                         }
{------------------------------------------------------------------}

procedure TimeDelay (hold : integer);
type
  RegRec =                                { The data to pass to DOS }
    record
      AX, BX, CX, DX, BP, SI, DI, DS, ES, Flags : Integer;
    end;
var
  regs:regrec;
  ah, al, ch, cl, dh:byte;
  sec               :string[2];
  tmptime, result, secn, error, secn2, diff :integer;

begin
  ah := $2c;
  with regs do
  begin
    ax := ah shl 8 + al;
  end;
  intr($21,regs);
  with regs do
  begin
    str(dx shr 8:2, sec);
  end;
  if (sec[1] = ' ') then
    sec[1]:= '0';
  val(sec, secn, error);
  repeat                           { stay in this loop until the time }
     ah := $2c;                    { has expired }
     with regs do
     begin
        ax := ah shl 8 + al;
     end;
     intr($21,regs);
     with regs do
     begin
        str(dx shr 8:2, sec);
     end;
     if (sec[1] = ' ') then
        sec[1]:= '0';
     val(sec, secn2, error);
     diff := secn2 - secn;
     if diff < 0 then            { we just went over the minute }
        diff := diff + 60;       { so add 60 seconds }
  until diff > hold;             { has our time expired yet }
end; { procedure TimeDelay }

